org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class SelectStep<S,E>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep<S,Map<String,E>>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.SelectStep<S,E>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Map<String,E>>>, Step<S,Map<String,E>>, ByModulating, PathProcessor, Scoping, TraversalParent

      public final class SelectStep<S,E>
      extends MapStep<S,Map<String,E>>
      implements Scoping, TraversalParent, PathProcessor, ByModulating

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `Scoping.Variable`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `PathProcessor.ElementRequirement`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SelectStep(Traversal.Admin traversal, Pop pop, String... selectKeys)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `SelectStep<S,E>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `Map<String,Traversal.Admin<Object,E>>` | `getByTraversals()`
    `Set<String>` | `getKeepLabels()`
    `List<Traversal.Admin<Object,E>>` | `getLocalChildren()`
    `Pop` | `getPop()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `Set<String>` | `getScopeKeys()` Get the labels that this scoping step will access during the traversal
    `int` | `hashCode()`
    `protected Map<String,E>` | `map(Traverser.Admin<S> traverser)`
    `void` | `modulateBy(Traversal.Admin<?,?> selectTraversal)`
    `protected Traverser.Admin<Map<String,E>>` | `processNextStart()`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setKeepLabels(Set<String> keepLabels)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `getNullableScopeValue, getScopeValue`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `getMaxRequirement, processTraverserPathLabels`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### SelectStep

          public SelectStep(Traversal.Admin traversal,
                            Pop pop,
                            String... selectKeys)

  - ### Method Detail

    - #### map

          protected Map<String,E> map(Traverser.Admin<S> traverser)

      Specified by:
        `map` in class `MapStep<S,Map<String,E>>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,Map<String,E>>`
      Overrides:
        `reset` in class `AbstractStep<S,Map<String,E>>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,Map<String,E>>`

    - #### clone

          public SelectStep<S,E> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,Map<String,E>>`
      Overrides:
        `clone` in class `AbstractStep<S,Map<String,E>>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,Map<String,E>>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,Map<String,E>>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,Map<String,E>>`

    - #### getLocalChildren

          public List<Traversal.Admin<Object,E>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> selectTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,Map<String,E>>`
      Returns:
        the set of requirements

    - #### getScopeKeys

          public Set<String> getScopeKeys()

      Description copied from interface: `Scoping`
      Get the labels that this scoping step will access during the traversal
      Specified by:
        `getScopeKeys` in interface `Scoping`
      Returns:
        the accessed labels of the scoping step

    - #### getByTraversals

          public Map<String,Traversal.Admin<Object,E>> getByTraversals()

    - #### getPop

          public Pop getPop()

    - #### setKeepLabels

          public void setKeepLabels(Set<String> keepLabels)

      Specified by:
        `setKeepLabels` in interface `PathProcessor`

    - #### getKeepLabels

          public Set<String> getKeepLabels()

      Specified by:
        `getKeepLabels` in interface `PathProcessor`

    - #### processNextStart

          protected Traverser.Admin<Map<String,E>> processNextStart()

      Overrides:
        `processNextStart` in class `MapStep<S,Map<String,E>>`

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.